Attribute VB_Name = "MdlCutObject"
Option Explicit
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function CreateRoundRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long) As Long
Public Declare Function CreateEllipticRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Public Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function SetWindowRgn Lib "User32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Long) As Long

Public Const RGN_COPY = 5
Public Const RGN_AND = 1
Public Const RGN_XOR = 3
Public Const RGN_OR = 2
Public Const RGN_MIN = RGN_AND
Public Const RGN_MAX = RGN_COPY
Public Const RGN_DIFF = 4

Dim RngArray() As Long
Dim RngIndex As Integer

Private Function lGetRegion(Pic As Object, lBackColor As Long) As Long
Dim lRgn As Long
Dim lSkinRgn As Long
Dim lStart As Long
Dim lX As Long
Dim lY As Long
Dim lHeight As Long
Dim lWidth As Long
Dim ms As Long
Static str$
lSkinRgn = CreateRectRgn(0, 0, 0, 0)
With Pic
    lHeight = .ScaleHeight
    lWidth = .ScaleWidth
    For lX = 0 To lHeight - 1
        lY = 0
        Do While lY < lWidth
            Do While lY < lWidth And GetPixel(.hDC, lY, lX) = lBackColor
                lY = lY + 1
            Loop
            If lY < lWidth Then
                lStart = lY
                Do While lY < lWidth And GetPixel(.hDC, lY, lX) <> lBackColor
                    lY = lY + 1
                Loop
                If lY > lWidth Then lY = lWidth
                lRgn = CreateRectRgn(lStart, lX, lY, lX + 1)
                str = str & vbCrLf & lRgn
                CombineRgn lSkinRgn, lSkinRgn, lRgn, RGN_OR
                DeleteObject lRgn
            End If
        Loop
    Next
End With
lGetRegion = lSkinRgn
End Function
Public Sub EraseMyArraY()
Erase RngArray()
RngIndex = 0
End Sub
Public Sub CreateCut(Color As Long, hwnd As Long, Pic As Object)
Dim lRgn As Long
RngIndex = RngIndex + 1
ReDim Preserve RngArray(RngIndex)
RngArray(RngIndex) = lGetRegion(Pic, Color)
End Sub

Public Sub UseCutRng(Index As Integer, hwnd As Long)
 SetWindowRgn hwnd, RngArray(Index), True
 'DeleteObject RngArray(Index)
End Sub

